/* Tizen - Xibo | Native Image Module */

/* global LayoutManager, utils, Logger */
(function() {
	"use strict";

	window.LayoutManager.image = function (media, container, callback, layoutid, scheduleid, scp) {
		if (media.media.audio !== undefined) {
			var audio = {
					uri : "file:///opt/usr/home/owner/content/Downloads/" + media.media.audio[0].uri[0].jValue,
					loop : media.media.audio[0].uri[0].jAttr.loop,
					volume : media.media.audio[0].uri[0].jAttr.volume
			};
			this.audiooverlay = new LayoutManager.audioOverlay(audio, container);
			this.audiooverlay.preload(function(){
				parent.audiooverlay.play();
			}, null);
		}

		this.statsStartTime = utils.getISODate();
		this.hashcode = Math.random();
		this.isready = false;
		this.align = null;
		this.valign = null;
		this.scaleType = null;
		if (media.media.options[0].align !== undefined){ this.align = media.media.options[0].align[0].jValue; } else { this.align = 'center'; }
		if (media.media.options[0].valign !== undefined){ this.valign = media.media.options[0].valign[0].jValue; } else { this.valign = 'middle'; }
		if (media.media.options[0].scaleType !== undefined){ this.scaleType = media.media.options[0].scaleType[0].jValue; } else { this.scaleType = 'center'; }

		this.duration = parseInt(media.duration);
		var duration = this.duration * 1000;
		if (media.isbase64 === 1) {
			this.uri = media.media.options[0].uri[0].jValue;
		} else {
			this.uri = "file:///opt/usr/home/owner/content/Downloads/" + media.media.options[0].uri[0].jValue;
		}
		this.elem = document.createElement("img");
		//this.elem.src = utils.downscaleImage(this.uri, container.clientWidth,"image/png",1);
		utils.downscaleImage(this.uri, container.clientWidth,"image/png",1, function(data){
			parent.elem.src = data;
		});
		//this.elem.src = this.uri;
		this.elem.setAttribute("scaleType", this.scaleType);
		this.elem.setAttribute("containerWidth", container.clientWidth);
		this.elem.setAttribute("containerHeight", container.clientHeight);
		this.elem.setAttribute("alignElement", this.align);
		this.elem.setAttribute("valignElement", this.valign);
		var parent = this;
		this.elem.onerror = function () {
			parent.timeoutElement = setTimeout(function(){
				if (parent.audiooverlay){
					parent.audiooverlay.stop();
				}
				callback();
			}, 5000, layoutid, scp);
		};
		this.timeoutElement = null;
		this.removeMedia = function () { 
			container.removeChild(parent.elem); 
		};
		var hastransIn = false;
		var hastransOut = false;
		var transInDuration = 1000;
		var transOutDuration = 1000;
		var transInType = null;
		var transOutType = null;
		var transInDirection = "S";
		var transOutDirection = "S";
		if (media.media.options[0].hasOwnProperty("transIn")){
          hastransIn = true; 
          transInType = media.media.options[0].transIn[0].jValue;
          if(media.media.options[0].transInDirection){
              transInDirection = media.media.options[0].transInDirection[0].jValue;
          }
          if (media.media.options[0].hasOwnProperty("transInDuration")){ 
            transInDuration = media.media.options[0].transInDuration[0].jValue; 
          }
        }
		if (media.media.options[0].hasOwnProperty("transOut")){ 
          hastransOut = true; 
          transOutType = media.media.options[0].transOut[0].jValue;
          if (media.media.options[0].transOutDirection){
            transOutDirection = media.media.options[0].transOutDirection[0].jValue; 
          }
          if (media.media.options[0].hasOwnProperty("transOutDuration")){ 
            transOutDuration = media.media.options[0].transOutDuration[0].jValue; 
          }
        }
	    if (hastransIn) { duration -= parseInt(transInDuration); }
		if (hastransOut) { duration -= parseInt(transOutDuration); }    
		if (duration < 0) { duration =0; }
		//var tag = "r: " + container.getAttribute("id") + " m: " + media.id + " image";
		this.timeoutMedia = function () {
			parent.timeoutElement = setTimeout(function(){
				if (hastransOut) {
					LayoutManager.transout(parent.elem, container, transOutType, transOutDuration, transOutDirection, function() { 
						if (parent.audiooverlay){
							parent.audiooverlay.stop();
						}
						if (scheduleid && media.enableStat !== "0"){
	                        Logger.logStat({fromdt: parent.statsStartTime, todt: utils.getISODate(), scheduleid: scheduleid, layoutid: layoutid, mediaid:media.id});
	                    }
						callback();
					});
				} else {
					if (parent.audiooverlay){
						parent.audiooverlay.stop();
					}
					if (scheduleid && media.enableStat !== "0"){
                        Logger.logStat({fromdt: parent.statsStartTime, todt: utils.getISODate(), scheduleid: scheduleid, layoutid: layoutid, mediaid:media.id});
                    }
					callback();
				}
			}, duration, layoutid, scp);
		};
		var timeoutMediaInvoke = this.timeoutMedia;
		this.displayThisMedia = function () {
			if (hastransIn) {
				utils.hide(this.elem);
			}
			container.innerHTML = null;
			container.appendChild(this.elem);
			if (hastransIn) {
				LayoutManager.transin(this.elem, container, transInType, transInDuration, transInDirection, function() {
					timeoutMediaInvoke(parent);
				});
			} else {
				timeoutMediaInvoke(parent);
			}
		};
		this.stopMediaTimeout = function () {
			if (parent.audiooverlay){
				parent.audiooverlay.stop();
			}
//			if (scheduleid){
//                Logger.logStat({fromdt: parent.statsStartTime, todt: utils.getISODate(), scheduleid: scheduleid, layoutid: layoutid, mediaid:media.id});
//            }
			clearTimeout(parent.timeoutElement);
		};
		this.elem.onload = function () {
			if (this.getAttribute('scaleType') === "stretch") {
				this.style.width = "100%";
				this.style.height = "100%";
			} else {
				var containerwidth = parseInt(this.getAttribute('containerWidth'));
				var containerheight = parseInt(this.getAttribute('containerHeight'));
				var widthRatio = containerwidth / this.width;
				var heightRatio = containerheight / this.height;
				var resizeRatio = Math.min(widthRatio, heightRatio);
				var newWidth = Math.ceil(resizeRatio*this.width);
				var newHeight = Math.ceil(resizeRatio*this.height);
				this.style.width = newWidth + "px";
				this.style.height = newHeight + "px";
				if (this.getAttribute('valignElement') === 'middle') {
					this.style.position = 'absolute';
					if (this.getAttribute('alignElement') === 'left') {
						this.style.left = 0;               
						this.style.top = ((parseInt(container.style.height) - parseInt(this.style.height))/2) + "px";
					} else if (this.getAttribute('alignElement') === 'right') {
						this.style.left = (parseInt(container.style.width) - parseInt(this.style.width)) + "px";
						this.style.top = ((parseInt(container.style.height) - parseInt(this.style.height))/2) + "px";
					} else {
						this.style.left = ((parseInt(container.style.width) - parseInt(this.style.width))/2) + "px";
						this.style.top = ((parseInt(container.style.height) - parseInt(this.style.height))/2) + "px";
					}
				} else if (this.getAttribute('valignElement') === 'top') {
					if (this.getAttribute('alignElement') === 'left') {
						this.style.left = 0;                        
						this.style.top = 0;                        
					} else if (this.getAttribute('alignElement') === 'right') {
						this.style.left = (parseInt(container.style.width) - parseInt(this.style.width)) + "px";
						this.style.top = 0;
					} else {
						this.style.left = ((parseInt(container.style.width) - parseInt(this.style.width))/2) + "px";
						this.style.top = 0;
					}
				} else if (this.getAttribute('valignElement') === 'bottom') {
					if (this.getAttribute('alignElement') === 'left') {
						this.style.left = 0;                        
						this.style.top = (parseInt(container.style.height) - parseInt(this.style.height)) + "px";
					} else if (this.getAttribute('alignElement') === 'right') {
						this.style.right = 0;                        
						this.style.top = (parseInt(container.style.height) - parseInt(this.style.height)) + "px";
					} else {
						this.style.left = ((parseInt(container.style.width) - parseInt(this.style.width))/2) + "px";
						this.style.top = (parseInt(container.style.height) - parseInt(this.style.height)) + "px";
					}
				}                                
			}
			parent.displayThisMedia(parent);
		};
	};
}());
